<?php

/**
 * Registering meta boxes
 *
 * All the definitions of meta boxes are listed below with comments.
 * Please read them CAREFULLY.
 *
 * You also should read the changelog to know what has been changed before updating.
 *
 * For more information, please visit:
 * @link http://www.deluxeblogtips.com/meta-box/
 */
add_filter('rwmb_meta_boxes', 'YOUR_PREFIX_register_meta_boxes');

/**
 * Register meta boxes
 *
 * @return void
 */
function YOUR_PREFIX_register_meta_boxes($meta_boxes) {

    // Check if plugin is activated or included in theme
    if (!class_exists('RW_Meta_Box'))
        return;
    /**
     * Prefix of meta keys (optional)
     * Use underscore (_) at the beginning to make keys hidden
     * Alt.: You also can make prefix empty to disable it
     */
    // Better has an underscore as last sign
    $prefix = '';

    // 1st meta box
    $meta_boxes[] = array(
        // Meta box id, UNIQUE per meta box. Optional since 4.1.5
        'id' => 'standard',
        // Meta box title - Will appear at the drag and drop handle bar. Required.
        'title' => __('زاوية الكاتب', 'rwmb'),
        // Post types, accept custom post types as well - DEFAULT is array('post'). Optional.
        'pages' => array('post'),
        // Where the meta box appear: normal (default), advanced, side. Optional.
        'context' => 'normal',
        // Order of meta box: high (default), low. Optional.
        'priority' => 'high',
        // Auto save: true, false (default). Optional.
        'autosave' => true,
        // List of meta fields
        'fields' => array(
            // TEXT
            array(
                // Field name - Will be used as label
                'name' => __('اسم الكاتب', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}authorname_field",
                // Field description (optional)
                //'desc'  => __( 'Text description', 'rwmb' ),
                'type' => 'text',
            // Default value (optional)
            //'std'   => __( 'Default text value', 'rwmb' ),
            // CLONES: Add to make the field cloneable (i.e. have multiple value)
            //'clone' => true,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('اسم الزاوية', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}cornername_field",
                // Field description (optional)
                //'desc'  => __( 'Text description', 'rwmb' ),
                'type' => 'text',
            // Default value (optional)
            //'std'   => __( 'Default text value', 'rwmb' ),
            // CLONES: Add to make the field cloneable (i.e. have multiple value)
            //'clone' => true,
            ),
            // THICKBOX IMAGE UPLOAD (WP 3.3+)
//			array(
//				'name' => __( 'Thickbox Image Upload', 'rwmb' ),
//				'id'   => "{$prefix}thickbox",
//				'type' => 'thickbox_image',
//			),
            // IMAGE ADVANCED (WP 3.5+)
            array(
                'name' => __('صورة الكاتب', 'rwmb'),
                'id' => "{$prefix}postuserpic2",
                'type' => 'image_advanced',
                'max_file_uploads' => 2,
            ),
        ),
    );

    return $meta_boxes;
}
