<?php
/**
 * The template for displaying Category pages.
 *
 * Used to display archive-type pages for posts in a category.
 *
 * Learn more: http://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Twenty_Twelve
 * @since Twenty Twelve 1.0
 */
get_header();
?>

<section id="primary" class="site-content">
    <div id="content" role="main">

        <?php if (have_posts()) : ?>
            <header class="archive-header">
                <h1 class="archive-title"><?php printf(__('Category Archives: %s', 'twentytwelve'), '<span>' . single_cat_title('', false) . '</span>'); ?></h1>

                <?php if (category_description()) : // Show an optional category description  ?>
                    <div class="archive-meta"><?php echo category_description(); ?></div>
                    <?php
                endif;
                $catgid = get_cat_ID(single_cat_title('', false));
                if (is_user_logged_in()) {
                    if (get_option('eg_setting_name') == 1 && $catgid == 15) { //school
                        echo "<a class='addformtopic' href='" . get_bloginfo('url') . "?page_id=261'>أضف إعلان</a>";
                    } else if (get_option('eg_setting_name') == 1 && $catgid == 16) {
                        echo "<a class='addformtopic' href='" . get_bloginfo('url') . "?page_id=356'>أضف إعلان</a>";
                    } else {
                        echo "<a class='addformtopic' href='" . get_bloginfo('url') . "/my-posts/?task=new&c={$catgid}'>أضف موضوع</a>";
                    }
                }
                ?>
            </header><!-- .archive-header -->

            <?php
            /* Start the Loop */
            while (have_posts()) : the_post();

                /* Include the post format-specific template for the content. If you want to
                 * this in a child theme then include a file called called content-___.php
                 * (where ___ is the post format) and that will be used instead.
                 */
                get_template_part('content', get_post_format());

            endwhile;

            twentytwelve_content_nav('nav-below');
            ?>

        <?php else : ?>
            <?php get_template_part('content', 'none'); ?>
<?php endif; ?>

    </div><!-- #content -->
</section><!-- #primary -->

<?php get_sidebar(); ?>
<?php get_footer(); ?>