<?php
/*

  Copyright (c) 2009 Anant Garg (anantgarg.com | inscripts.com)

  This script may be used for non-commercial purposes only. For any
  commercial purposes, please contact the author at
  anant.garg@inscripts.com

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
  OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
  WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
  OTHER DEALINGS IN THE SOFTWARE.

 */

define('MASTERYO', true);
define('FULL_PATH', str_replace('\\', '/', dirname(__FILE__)) . '/');
ini_set("session.gc_maxlifetime", "86400");
session_start();
$curr_session_id = session_id();

error_reporting(E_ALL ^ E_NOTICE);
set_error_handler('error_handler');

function error_handler($errno, $errmsg, $file, $line, $vars) {
    if (defined('E_STRICT')) {
        if ($errno & E_STRICT
                && (error_reporting() & E_STRICT) != E_STRICT) {
            // Ignore E_STRICT notices unless they have been turned on
            return;
        }
    } else {
        define('E_STRICT', 2048);
    }
    $errortype = array(
        E_ERROR => 'Error',
        E_WARNING => 'Warning',
        E_PARSE => 'Parsing Error',
        E_NOTICE => 'Notice',
        E_CORE_ERROR => 'Core Error',
        E_CORE_WARNING => 'Core Warning',
        E_COMPILE_ERROR => 'Compile Error',
        E_COMPILE_WARNING => 'Compile Warning',
        E_USER_ERROR => 'User Error',
        E_USER_WARNING => 'User Warning',
        E_USER_NOTICE => 'User Notice',
        E_STRICT => 'Strict Notice',
        E_DEPRECATED => 'Deprecated',
        8192 => 'Deprecated',
    );
    $prefix = $errortype[$errno];
    if ($prefix != 'Notice' && trim($prefix) != 'Warning' && $prefix != 'Deprecated' && $prefix != 'Strict Standards' && $prefix != 'Strict Notice') {

        print "\n $prefix: $errmsg in " . basename($file) . " on line " . $line . "\n<br />";
        if (function_exists(log_error))
            log_error("\n$prefix: $errmsg in " . basename($file) . " on line " . $line . "\n<br />");
    }
}


define('CONFIG_DIR', FULL_PATH . 'configs/');

if (!is_readable(FULL_PATH . 'configs/config.php')) {
    if (is_readable('install.php')) {
        die("<meta http-equiv='Refresh' content='0; URL=install.php'>");
    } else {
        die("<meta http-equiv='Refresh' content='0; URL=../install.php'>");
    }
}

if (file_exists(CONFIG_DIR . 'config.php')) {

    require_once( CONFIG_DIR . 'config.php' );

    if (ADMIN == 'true') {
        require FULL_PATH . 'admin/sessioninc.php';
    }
} else {

    echo (CONFIG_DIR . 'config.php is missing..<br />');

    exit;
}

require LIB_DIR . 'masteryoDB.php';
if (!isset($db)) {
    $db = new masteryoDB;
}
$db->query("SET character_set_database=" . $charset);
$db->query("SET character_set_server=" . $charset);
$db->query("SET NAMES " . $charset);
$db->query("SET character_set_client = '" . $charset . "'");
$db->query("SET character_set_connection = '" . $charset . "'");
#$db->query("SET collation_connection = 'utf8_unicode_ci'");
$db->query("SET character_set_results = '" . $charset . "'");


if ($_GET['action'] == "chatheartbeat") {
    chatHeartbeat();
}
if ($_GET['action'] == "sendchat") {
    sendChat();
}
if ($_GET['action'] == "closechat") {
    closeChat();
}
if ($_GET['action'] == "startchatsession") {
    startChatSession();
}

if (!isset($_SESSION['chatHistory'])) {
    $_SESSION['chatHistory'] = array();
}

if (!isset($_SESSION['openChatBoxes'])) {
    $_SESSION['openChatBoxes'] = array();
}

function chatHeartbeat() {

    $sql = "select * from chat where (chat.to = '" . mysql_real_escape_string($_SESSION['username']) . "' AND recd = 0) order by id ASC";
    $query = mysql_query($sql);
    $items = '';

    $chatBoxes = array();

    while ($chat = mysql_fetch_array($query)) {

        if (!isset($_SESSION['openChatBoxes'][$chat['from']]) && isset($_SESSION['chatHistory'][$chat['from']])) {
            $items = $_SESSION['chatHistory'][$chat['from']];
        }

        $chat['message'] = sanitize($chat['message']);

        $items .= <<<EOD
					   {
			"s": "0",
			"f": "{$chat['from']}",
			"m": "{$chat['message']}"
	   },
EOD;

        if (!isset($_SESSION['chatHistory'][$chat['from']])) {
            $_SESSION['chatHistory'][$chat['from']] = '';
        }

        $_SESSION['chatHistory'][$chat['from']] .= <<<EOD
						   {
			"s": "0",
			"f": "{$chat['from']}",
			"m": "{$chat['message']}"
	   },
EOD;

        unset($_SESSION['tsChatBoxes'][$chat['from']]);
        $_SESSION['openChatBoxes'][$chat['from']] = $chat['sent'];
    }

    if (!empty($_SESSION['openChatBoxes'])) {
        foreach ($_SESSION['openChatBoxes'] as $chatbox => $time) {
            if (!isset($_SESSION['tsChatBoxes'][$chatbox])) {
                $now = time() - strtotime($time);
                $time = date('g:iA M dS', strtotime($time));

                $message = "Sent at $time";
                if ($now > 180) {
                    $items .= <<<EOD
{
"s": "2",
"f": "$chatbox",
"m": "{$message}"
},
EOD;

                    if (!isset($_SESSION['chatHistory'][$chatbox])) {
                        $_SESSION['chatHistory'][$chatbox] = '';
                    }

                    $_SESSION['chatHistory'][$chatbox] .= <<<EOD
		{
"s": "2",
"f": "$chatbox",
"m": "{$message}"
},
EOD;
                    $_SESSION['tsChatBoxes'][$chatbox] = 1;
                }
            }
        }
    }

    $sql = "update chat set recd = 1 where chat.to = '" . mysql_real_escape_string($_SESSION['username']) . "' and recd = 0";
    $query = mysql_query($sql);

    if ($items != '') {
        $items = substr($items, 0, -1);
    }

    header('Content-type: application/json');
    $cn = custom_notice();
    ?>
    {
    "setting": "<?php echo $cn['setting'] ?>",
    "items": [<?php echo $items; ?>],
    "lists": [<?php echo join(',', $cn['lists']); ?>],
    "interest" : [<?php echo join(',', $cn['interest']); ?>]
    ,"msg" : <?php echo json_encode($cn['inboxs']); ?>
    }

    <?php
    exit(0);
}

function chatBoxSession($chatbox) {

    $items = '';

    if (isset($_SESSION['chatHistory'][$chatbox])) {
        $items = $_SESSION['chatHistory'][$chatbox];
    }

    return $items;
}

function startChatSession() {
    echo "sasa";
    exit();
    $items = '';
    if (!empty($_SESSION['openChatBoxes'])) {
        foreach ($_SESSION['openChatBoxes'] as $chatbox => $void) {
            $items .= chatBoxSession($chatbox);
        }
    }


    if ($items != '') {
        $items = substr($items, 0, -1);
    }
    $cn = custom_notice();
    header('Content-type: application/json');
    ?>
    {
    "setting": "<?php echo $cn['setting'] ?>",
    "username": "<?php echo $_SESSION['username']; ?>",
    "items": [<?php echo $items; ?>],
    "lists": [<?php echo join(',', $cn['lists']); ?>],
    "interest" : [<?php echo join(',', $cn['interest']); ?>],
    "msg" : <?php echo json_encode($cn['inboxs']); ?>
    }

    <?php
    exit(0);
}

function sendChat() {
    $from = $_SESSION['username'];
    $to = $_POST['to'];
    $message = $_POST['message'];

    $_SESSION['openChatBoxes'][$_POST['to']] = date('Y-m-d H:i:s', time());

    $messagesan = sanitize($message);

    if (!isset($_SESSION['chatHistory'][$_POST['to']])) {
        $_SESSION['chatHistory'][$_POST['to']] = '';
    }

    $_SESSION['chatHistory'][$_POST['to']] .= <<<EOD
					   {
			"s": "1",
			"f": "{$to}",
			"m": "{$messagesan}"
	   },
EOD;


    unset($_SESSION['tsChatBoxes'][$_POST['to']]);

    $sql = "insert into chat (chat.from,chat.to,message,sent) values ('" . mysql_real_escape_string($from) . "', '" . mysql_real_escape_string($to) . "','" . mysql_real_escape_string($message) . "',NOW())";
    $query = mysql_query($sql);
    echo "1";
    exit(0);
}

function closeChat() {

    unset($_SESSION['openChatBoxes'][$_POST['chatbox']]);

    echo "1";
    exit(0);
}

function sanitize($text) {
    $text = htmlspecialchars($text, ENT_QUOTES);
    $text = str_replace("\n\r", "\n", $text);
    $text = str_replace("\r\n", "\n", $text);
    $text = str_replace("\n", "<br>", $text);
    return $text;
}

function custom_notice() {
    //chat list by masteryo
    global $db, $dbPrefix;
    $my_list = $db->getAll("SELECT ref_userid FROM ! WHERE userid = '!' AND act = 'F' and status = 'active'", array($dbPrefix . '_marriage_buddy', $_SESSION['member']['member_id']));
    $like_me = $db->getAll("SELECT id ,userid FROM ! WHERE ref_userid = '!' AND act = 'F' and status = 'active'", array($dbPrefix . '_marriage_buddy', $_SESSION['member']['member_id']));
    if (count($my_list) > 0 && is_array($my_list)) {
        foreach ($my_list as $i => $v) {
            $status = 'pending';
            $login = $db->getOne("SELECT login FROM ! WHERE member_id = '!'", array($dbPrefix . '_members', $v['ref_userid']));
            foreach ($like_me as $ii => $vv) {
                if ($v['ref_userid'] == $vv['userid'])
                    $status = 'accepted';
            }
            //update current member online time , in case if he stop browsing other pages but still on the site
            $db->query("UPDATE ! SET time='!' WHERE member_id = !", array($dbPrefix . '_online', time(), $_SESSION['member']['member_id']));
            
            $online_now = $db->getRow("SELECT member_id,session FROM ! WHERE member_id = '!'
								  AND  time > " . (time() - 600) . " ", array($dbPrefix . '_online', $v['ref_userid']));
            if ($online_now['member_id'] > 0)
                $online = 'Y';
            else
                $online = 'N';
            $lists[] = '{"login" : "' . $login . '","status": "' . $status . '","online" :"' . $online . '","online_session" :"' . $online_now['session'] . '"}';
        }
    } else {
        $lists[] = '{"list" : "none"}';
    }
    unset($i, $ii, $v, $vv, $login);
    //new adding to interested list
   /* if (count($like_me) > 0 && is_array($like_me)) {
        foreach ($like_me as $i => $v) {
            $continue = false;
            foreach ($my_list as $ii => $vv)
                if ($v['userid'] == $vv['ref_userid'])
                    $continue = true;
            if ($continue == true)
                continue;
            $login = $db->getOne("SELECT login FROM ! WHERE member_id = '!'", array($dbPrefix . '_members', $v['userid']));
            $interest[] = '{"login" : "' . $login . '" , "id": "' . $v['id'] . '","member_id":"' . $v['userid'] . '"}';
        }
        if (!$interest
        )
            $interest[] = '{"login" : "none"}';
    } else {
        $interest[] = '{"login" : "none"}';
    }

    //check for new messages
    $inbox = $db->getAll("select id,senderid from ! where owner = '!' and folder = 'inbox' and flagread = '0'", array($dbPrefix . '_mailbox', $_SESSION['member']['member_id']));
    $inboxs['inbox'] = array();
    $inboxs['num_of_inbox'] = 0;
    if (count($inbox) > 0 && is_array($inbox)) {
        foreach ($inbox as $k => $v) {
            $inboxs['inbox'][$k]['id'] = $v['id'];
            $from = $db->getOne("SELECT login FROM ! WHERE member_id = '!'", array($dbPrefix . '_members', $v['senderid']));
            $inboxs['inbox'][$k]['from'] = (!$from) ? 'الإدارة' : $from;
        }
        $inboxs['num_of_inbox'] = count($inboxs['inbox']);
    }
    return array('setting' => $_SESSION['member']['additional_fields']['notice_message'], 'lists' => $lists, 'interest' => $interest, 'inboxs' => $inboxs);
*/}