<?php
/**
 * The default template for displaying content. Used for both single and index/archive/search.
 *
 * @package WordPress
 * @subpackage Twenty_Twelve
 * @since Twenty Twelve 1.0
 */
?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
    <?php if (is_sticky() && is_home() && !is_paged()) : ?>
        <div class="featured-post">
            <?php _e('Featured post', 'twentytwelve'); ?>
        </div>
    <?php endif; ?>
    <header class="entry-header">

        <?php if (is_single()) : ?>
            <h1 class="entry-title"><?php the_title(); ?></h1>
        <?php else : ?>
            <h1 class="entry-title">
                <a href="<?php the_permalink(); ?>" rel="bookmark"><?php echo truncate(get_the_title(),70); ?></a>
            </h1>
        <?php
        endif; // is_single() 

        /*         * ******************* */

        $categories_list = get_the_category_list(__(', ', 'twentytwelve'));
        global $current_user;

        global $wpdb;

        // Translators: used between list items, there is a space after the comma.
        $tag_list = get_the_tag_list('', __(', ', 'twentytwelve'));

        $date = sprintf('<a href="%1$s" title="%2$s" rel="bookmark"><time class="entry-date" datetime="%3$s">%4$s</time></a>', esc_url(get_permalink()), esc_attr(get_the_time()), esc_attr(get_the_date('c')), esc_html(get_the_date())
        );

        $author = sprintf('<span class="author vcard"><a class="url fn n" href="%1$s" title="%2$s" rel="author">%3$s</a></span>', esc_url(get_author_posts_url(get_the_author_meta('ID'))), esc_attr(sprintf(__('View all posts by %s', 'twentytwelve'), get_the_author())), get_the_author()
        );

        // Translators: 1 is category, 2 is tag, 3 is the date and 4 is the author's name.
        if ($tag_list) {
            $utility_text = __('This entry was posted in %1$s and tagged %2$s on %3$s<span class="by-author"> by %4$s</span>.', 'twentytwelve');
        } elseif ($categories_list) {
            $utility_text = __('This entry was posted in %1$s on %3$s<span class="by-author"> by %4$s</span>.', 'twentytwelve');
        } else {
            $utility_text = __('This entry was posted on %3$s<span class="by-author"> by %4$s</span>.', 'twentytwelve');
        }

        /*  printf(
          $utility_text, $categories_list, $tag_list, $date, $author
          ); */
        $nowdate = new DateTime();
        $authorid = get_the_author_ID();
        $lastuservisit = get_user_meta($authorid, 'lastvisit', true);
        $userdesc = get_user_meta($authorid, 'descrptn', true);

        $check = $wpdb->query(
                $wpdb->prepare(
                        "
                                select `r_id` from $wpdb->my_buddy
                                where (userid= %d and ref_userid= %d) or (userid= %d and ref_userid= %d) 
                                ", $current_user->ID, $authorid, $authorid, $current_user->ID
                )
        );
        if ($check == 0 && $authorid != 0 && is_user_logged_in() && $authorid != $current_user->ID) {

            $addfr = "<a class='addfriend addfriend" . $authorid . "' id='" . $authorid . "' href=''>أضف صديق</a>
                <span class='requestadd" . $authorid . "'></span>";
        }

        $userlogin = get_userdata(get_the_author_ID())->user_login;
        if ($current_user->ID != get_the_author_ID()) {
        $sendpm = "<a class='sendpm' href='" . get_bloginfo('url') . "/336-2/?dpm=folder&folder=5&receiver=" . $userlogin . "'>أرسل رسالة</a>";}
        else {$sendpm='';}
        echo "<div class='post-info'>";
            if (is_user_logged_in()) {
                if ($nowdate->getTimestamp() - $lastuservisit <= 50)
                    echo "<div class='writtenby'><div>بواسطة: <label class='onlineicon'>$author</label></div>" . " " . $addfr . $sendpm . $userdesc . "</div>";
                else
                    echo "<div class='writtenby'><div>بواسطة: <label class='offlineicon'>$author</label></div>" . " " . $addfr . $sendpm . $userdesc . "</div>";
            }
            else
                echo "<div class='writtenby'><div>بواسطة: <label>$author</label></div>" . " " . $addfr . " " . $userdesc . "</div>";

            echo "<div class='date'>$date</div></div>";





            /*             * ************************** */
            ?>
            <?php /* if ( comments_open() ) : ?>
              <div class="comments-link">
              <?php comments_popup_link( '<span class="leave-reply">' . __( 'Leave a reply', 'twentytwelve' ) . '</span>', __( '1 Reply', 'twentytwelve' ), __( '% Replies', 'twentytwelve' ) ); ?>
              </div><!-- .comments-link -->
              <?php endif; // comments_open() */ ?>
        </header><!-- .entry-header -->

        <?php if (is_search() || is_home() || is_archive()) : // Only display Excerpts for Search  ?>
            <div class="entry-summary">
                 
                 <?php add_image_size( 'small_thumbnail', 100, 100, true );  the_post_thumbnail('small_thumbnail');
                        the_excerpt(); ?>
            </div><!-- .entry-summary -->
        <?php else : ?>

            <div class="entry-content">
                <?php the_content(__('Continue reading <span class="meta-nav">&rarr;</span>', 'twentytwelve')); ?>
                <?php
                /* $content = get_the_content();
                  $content = strip_tags($content);
                  $content=truncate($content, 400);
                  echo $content; */
                ?>
                <?php wp_link_pages(array('before' => '<div class="page-links">' . __('Pages:', 'twentytwelve'), 'after' => '</div>')); ?>
            </div><!-- .entry-content -->
        <?php endif; ?>

        <footer class="entry-meta">
            <?php twentytwelve_entry_meta(); ?>
            <?php edit_post_link(__('Edit', 'twentytwelve'), '<span class="edit-link">', '</span>'); ?>
            <?php if(!is_single()): ?>
            <a href='<?php the_permalink() ?>'>المزيد</a>
            <?php endif; ?>
            <?php if (is_singular() && get_the_author_meta('description') && is_multi_author()) : // If a user has filled out their description and this is a multi-author blog, show a bio on their entries.   ?>
                <div class="author-info">
                    <div class="author-avatar">
                        <?php echo get_avatar(get_the_author_meta('user_email'), apply_filters('twentytwelve_author_bio_avatar_size', 68)); ?>
                    </div><!-- .author-avatar -->
                    <div class="author-description">
                        <h2><?php printf(__('About %s', 'twentytwelve'), get_the_author()); ?></h2>
                        <p><?php the_author_meta('description'); ?></p>
                        <div class="author-link">
                            <a href="<?php echo esc_url(get_author_posts_url(get_the_author_meta('ID'))); ?>" rel="author">
                                <?php printf(__('View all posts by %s <span class="meta-nav">&rarr;</span>', 'twentytwelve'), get_the_author()); ?>
                            </a>
                        </div><!-- .author-link	-->
                    </div><!-- .author-description -->
                </div><!-- .author-info -->
            <?php endif; ?>
    </footer><!-- .entry-meta -->
</article><!-- #post -->
